;;; -*- mode: lisp -*-

;; 2011-12-21  NANRI Masaoki  <southly@gmail.com>
;; 
;; 	* lisp : fix saving session file.
;; 	qXgt@CƓlɃZbVt@Cݎ *print-length*
;; 	Ȃǂ̉e󂯂Ȃ悤CB
;; 
;; 	(progn
;; 	  (ed::write-session-file "0ssn.l")
;; 	  (let ((*print-circle* t)
;; 	        (*print-pretty* nil)
;; 	        (*print-length* 1)
;; 	        (*print-level* 1))
;; 	    (ed::write-session-file "1ssn.l")))
;;
(deftest fix-saving-session-file ()
  "ZbVt@Cۑ *print-length* Ȃǂ̉e󂯂Ȃ悤ɏCB"
  (with-temp-files (ssn)
    (block test
      (with-fake-functions ((write (object &key pretty readably escape)
                              (unless (or (stringp object)
                                          (and pretty readably escape))
                                (return-from test nil))))
        (let ((*print-circle* t)
              (*print-pretty* nil)
              (*print-length* 1)
              (*print-level* 1))
          (ed::write-session-file ssn))
        t)))
  => non-nil)

;; 	* lisp : fix saving history-file.
;; 	qXgt@Cݎ *print-length* Ȃǂ̉e󂯂̂CB
;; 
;; 	(progn
;; 	  (let ((*history-file-name* "0hist.l"))
;; 	    (ed::save-history-file))
;; 	  (let ((*history-file-name* "1hist.l")
;; 	        (*print-circle* t)
;; 	        (*print-pretty* nil)
;; 	        (*print-length* 1)
;; 	        (*print-level* 1))
;; 	    (ed::save-history-file)))
;;
(deftest fix-saving-history-file ()
  "qXgt@Cݎ *print-length* Ȃǂ̉e󂯂̂CB"
  ;; NOTE: xyzzy.exe -q ŋNĂƃqXgt@CgȂɂȂႤ̂
  (unless ed::*history-file-loaded*
    (trap-errors (ed::load-history-file)))
  (with-temp-files (histfile)
    (block test
      (with-fake-functions ((write (object &key pretty readably escape)
                              (unless (and pretty readably escape)
                                (return-from test nil))))
        (let ((*history-file-name* histfile)
              (*print-circle* t)
              (*print-pretty* nil)
              (*print-readably* nil)
              (*print-length* 1)
              (*print-level* 1))
          (ed::save-history-file))
        t)))
  => non-nil)

;; 2011-12-20  NANRI Masaoki  <southly@gmail.com>
;; 
;; 	* src : fix equalp for hash-table.
;; 	equalp  hash-table nƑlԂĂCB
;; 	https://gist.github.com/1480046
;; 
(deftest equalp-for-hash-table ()
  "equalp  hash-table nƑlIĂCB"
  (let ((a (make-hash-table))
        (b (make-hash-table)))
    (setf (gethash 1 a) "foo"
          (gethash 1 b) "foo")
    (equalp a b))
  => t)

;; 2011-06-17  NANRI Masaoki  <southly@gmail.com>
;; 
;; 	* src : fix sxhash.
;; 	sxhash ̒l equalp p̒lɂȂĂ邪 equal p̒lɂȂ悤ɏCB
;; 	(= (sxhash (list "ABC")) (sxhash (list "ABC"))) => t
;; 	(= (sxhash (list "abc")) (sxhash (list "ABC"))) => nil
;;
;; NOTE: ͌IbP[
; (deftest sxhash-fix-00 ()
;   (= (sxhash (list "ABC")) (sxhash (list "ABC")))
;   => t)
 
(deftest sxhash-fix-01 ()
  "sxhash ̒l equalp p̒lɂȂĂ equal p̒lɏCB"
  (= (sxhash (list "abc")) (sxhash (list "ABC")))
  => nil)

;; 2011-06-15  NANRI Masaoki  <southly@gmail.com>
;; 
;; 	* lisp : fix compiling lambda form.
;; 	lambda form RpCƃLVJϐQƂłȂȂĂ
;; 	CB
;; 	https://gist.github.com/998414
;; 	https://gist.github.com/1000096
;; 
(deftest fix-compiling-lambda-form ()
  "lambda form RpCƃLVJϐQƂłȂȂĂCB"
  (compile-and-eval
    (let ((a 1))
      ((lambda () a))))
  => 1)

;; 2011-06-14  NANRI Masaoki  <southly@gmail.com>
;; 
;; 	* lisp : fix typo in lisp/compile.l.
;; 	֐̃~XCB
;; 	https://twitter.com/#!/bowbow99/status/80332901014704128
;;
(deftest fix-typo-in-lisp/compile.l ()
  "lisp/compile.l ̊֐ typo Cis/nineth/ninth/jB"
  (progn
    (require "compile")
    (functionp (get 'ninth (find-symbol "optimize-form" :compiler))))
  => non-nil)

;; 2011-01-30  NANRI Masaoki  <southly@gmail.com>
;; 
;; 	* src : fix abbreviate-display-string.
;; 	abbreviate-display-string ŕKvȏɕ񂪏ȗ邱Ƃ̂
;; 	CBȉ̂悤ɂȂꍇB
;; 	(abbreviate-display-string "D:/src/cmigemo-1.3c-MIT/src/wordlist.h" 40 t)
;; 	=> "D:/..."
;; 
;; 	string.cc  1109 sځAȉ̂悤ɂȂĂB
;; 	  strcpy (le, "...");
;; 	  strcpy (le + 3, rb);
;; 	͂߂ strcpy  '\0' ܂Äʒu傤 rb ƈv
;; 	ƂɔB
;;
(deftest fix-abbreviate-display-string ()
  "abbreviate-display-string ŕKvȏɕ񂪏ȗ邱Ƃ̂CB"
  (abbreviate-display-string "D:/src/cmigemo-1.3c-MIT/src/wordlist.h" 40 t)
  => "D:/.../cmigemo-1.3c-MIT/src/wordlist.h")


;; 2011-01-21  NANRI Masaoki  <southly@gmail.com>
;; 
;; 	* lisp : fix pipe-command.
;; 	uplink name@example.jp lsv plink 𗘗p悤Ƃ
;; 	uUnable to read from standard input: nhłBv
;; 	ƂG[ɂȂ̂CB
;; 
;; 	execute-shell-command ̑ɕEnilȊÖnƃt@C
;; 	̃t@CJƂ̂ŁAG[ɂȂĂ͗lB
;; 
;; NOTE: ύX̓e悭ĂȂAύXĂ邩`FbNB
(deftest fix-pipe-command ()
  "pipe-command  execute-shell-command ɓnԈĂ̂CiԂj"
  (with-fake-functions ((execute-shell-command (a b c) b))
    (pipe-command "duh.."))
  => nil)

;; 	* src : fix wheel icon.
;; 	ȂƂȂzC[{^NbNƂ̃ACRĂ݂B
;; 
;; NOTE: eXgsvƁBB

;; 	* src : fix multiple binding of special variables in let, let*.
;; 	http://d.hatena.ne.jp/bowbow99/20101127/1290818576
;; 	let  let* œ̃XyVϐɑ΂ĕ̑Ƃ̒l
;; 	̂CB
;; 	RpCƂ̓͏CłĂȂB
;; 	(progn
;; 	  (defparameter *special* :global)
;; 	  (let ((*special* :local-1)
;; 	        (*special* :local-2))
;; 	    *special*))
;; 	=> :local-2
;; 
;; 	LVJȊɂ͋tɓo^̂ŁAXyVϐɒlݒ肷
;; 	Oɏɖ߂ĂB
;; 
(deftest fix-multiple-binding-of-special-variable-in-let/let*-00 ()
  "let œ̃XyVϐɑ΂ĕ̑Ƃ̒l
̂CB"
  (progn
    (defparameter *special* :global)
    (let ((*special* :local-1)
          (*special* :local-2))
      *special*))
  => :local-2)

(deftest fix-multiple-binding-of-special-variable-in-let/let*-01 ()
  "let* œ̃XyVϐɑ΂ĕ̑Ƃ̒l
̂CB"
  (progn
    (defparameter *special* :global)
    (let* ((*special* :local-1)
           (*special* :local-2))
      *special*))
  => :local-2)

;; 2011-01-05  NANRI Masaoki  <southly@gmail.com>
;; 
;; 	* src : fix let, let*.
;; 	http://d.hatena.ne.jp/bowbow99/20101127/1290818576
;; 	RpCƂ͒lς邱Ƃ͂ȂAC^v^Ɠlɋt
;; 	lXgA悤ɏCB
;;
;; NOTE: ͌ĂȂi͕ςĂȂj
; (deftest fix-let/let*-multiple-bind-for-special-variable-in-compiled-code ()
;   (progn
;     (defparameter *special* :global)
;     (funcall
;      (compile nil
;               ;; NOTE: need empty lexenv to compile
;               (eval '(lambda ()
;                       (let ((*special* :local-1)
;                             (*special* :local-2))
;                         *special*)))))
;     *special*)
;   => :global)

;; 2011-01-04  NANRI Masaoki  <southly@gmail.com>
;; 
;; 	* src : fix special variables restore at the end of let, let*.
;; 	http://d.hatena.ne.jp/bowbow99/20101127/1290818576
;; 	let  let* œ̃XyVϐɑ΂ĕ̑ƁAXR[
;; 	vOꂽƂɒlĂ܂̂CB
;; 	(progn
;; 	  (defparameter *special* :global)
;; 	  (let ((*special* :local-1)
;; 	        (*special* :local-2))
;; 	    *special*)
;; 	  *special*)
;; 	=> :global
;; 
;; 	lۑƂ(src/eval.cc 347sڕӂ)ƋtɒlXgA悤
;; 	B
;; 
(deftest fix-special-variables-restore-at-the-end-of-let/let*-00 ()
  "let œ̃XyVϐɑ΂ĕ̑ƁAXR[
vOꂽƂɒlĂ܂̂CB"
  (progn
    (defparameter *special* :global)
    (let ((*special* :local-1)
          (*special* :local-2))
      *special*)
    *special*)
  => :global)

(deftest fix-special-variables-restore-at-the-end-of-let/let*-01 ()
  "let* œ̃XyVϐɑ΂ĕ̑ƁAXR[
vOꂽƂɒlĂ܂̂CB"
  (progn
    (defparameter *special* :global)
    (let* ((*special* :local-1)
           (*special* :local-2))
      *special*)
    *special*)
  => :global)

;; 2010-12-14  NANRI Masaoki  <southly@gmail.com>
;; 
;; 	* src : fix eol-code of zero size file.
;; 	t@CTCY 0 ̂Ƃ (mɂ͉sȂt@ĈƂ) sR[
;; 	h CRLF ɂȂ̂C *default-eol-code* ɊÂsR[h
;; 	ɂȂ悤ɂB
;; 	xyzzy Part16 577
;;
(deftest fix-eol-code-of-zero-size-file ()
  "t@CTCY 0 ̂Ƃ (mɂ͉sȂt@ĈƂ) sR[
h CRLF ɂȂ̂C *default-eol-code* ɊÂsR[h
ɂȂ悤ɂB"
  (with-temp-files (name)
    (let (buffer)
      (with-open-file (out name :direction :output :if-does-not-exist :create))
      (unwind-protect
          (let ((*default-eol-code* *eol-lf*))
            (declare (special *default-eol-code*))
            (setq buffer (ed::find-file-internal name))
            (buffer-eol-code buffer))
        (delete-buffer buffer))))
  => 0)

;; 2010-12-13  NANRI Masaoki  <southly@gmail.com>
;; 
;; 	* src : fix DLL loading (hhctrl.ocx).
;; 	JVNVU#707943: Windows vO DLL ǂݍ݂ɐƎ㐫
;; 	http://jvn.jp/cert/JVNVU707943/index.html
;; 	̏C̑B
;; 	hhctrl.ocx ̃[h͐ÓIϐ̏ɍs邽߁ȀČʂ
;; 	y΂ȂBāA[h̃^C~O֐ html-help ĂяoɕύXB
;; 
;; 	* src : fix DLL loading.
;; 	JVNVU#707943: Windows vO DLL ǂݍ݂ɐƎ㐫
;; 	http://jvn.jp/cert/JVNVU707943/index.html
;; 	̏CB
;; 	A[JCo DLL  WSOCK32.DLL  ctl3d32.dll ΏہB
;; 	foreign:define-dll-entry (si:load-dll-module) Ŏw肷 DLL ΏۂA
;; 	̓tpXŎw肷̂]܂낤B
;; 
;; TODO: eLg[ dll ǂݍŃeXgHH

;; 2010-12-12  NANRI Masaoki  <southly@gmail.com>
;; 
;; 	* src : update zlib(version 1.2.5).
;; 	zlibo[W1.2.5ɃAbvf[gB
;; 
;; 	* lisp : support lzma and xz in filer.
;; 	lzma  xz ̈kƓWJt@C痘pł悤ɏCB
;; 
(deftest lzma-support-in-filer-00 ()
  "lzma ̈kƓWJt@C痘pł悤ɏCB"
  (member "*.lzma" (cdr (assoc "A[JCu" ed:*filer-path-masks* :test #'string=))
          :test #'string=)
  => non-nil)

(deftest lzma-support-in-filer-01 ()
  (with-fake-functions ((dialog-box (&rest args)
                          (values t '((ed::name . "foo.tar.lzma")
                                      (ed::dir . "C:/dir")
                                      (ed::base . "dir"))))
                        (ed::add-history (&rest args) t)
                        (ed::filer-get-directory () "C:/"))
    (ed::filer-get-archive-name))
  => "C:/dir/foo.tar.lzma"
  => "C:/dir")

(deftest xz-support-in-filer-00 ()
  "xz ̈kƓWJt@C痘pł悤ɏCB"
  (member "*.xz" (cdr (assoc "A[JCu" ed:*filer-path-masks* :test #'string=))
          :test #'string=)
  => non-nil)

(deftest xz-support-in-filer-01 ()
  (with-fake-functions ((dialog-box (&rest args)
                          (values t '((ed::name . "foo.tar.xz")
                                      (ed::dir . "C:/dir")
                                      (ed::base . "dir"))))
                        (ed::add-history (&rest args) t)
                        (ed::filer-get-directory () "C:/"))
    (ed::filer-get-archive-name))
  => "C:/dir/foo.tar.xz"
  => "C:/dir")

;; 	* src : support lzma and xz.
;; 	tar32.dll Ver2.35 痘pł悤ɂȂ lzma  xz ̈kƓW
;; 	JɑΉB
;;

;; 2010-12-11  NANRI Masaoki  <southly@gmail.com>
;; 
;; 	* src : fix hash-table.
;; 	rehash ɕsvȃnbVIuWFNg̃Gg[ NULL ɐݒ肵Ă
;; 	̂ŁATCY 0 ɐݒ肷Bhash-table ̃}[NtF[Y(data.cc613s
;; 	ڂ) NULL QƂ̂h~B
;; 	ȉ̂悤 hash-table  rehash  GC ̃^C~Oŗ錻
;; 	炭ƎvB
;; 	http://twitter.com/miyamuko/status/14229437114
;; 	http://d.hatena.ne.jp/knenet/20091223/1261578863
;; 
;; FIXME: ułȂŒ`ꂽ֐̓RpCł܂v
; (deftest fix-hash-table-and-gc-crash ()
;   (with-another-xyzzy (:options "-q")
;     (defun xn ()
;       (let ((tb (make-hash-table)))
;         (dotimes (a 10000 :done)
;           (let* ((p (f))
;                  (n (gethash p tb)))
;             (setf (gethash p tb) (if n (1+ n) 1))))))
;     (defun f ()
;       (let ((p 0))
;         (dotimes (- 20 p)
;           (if (< 0.4 (random 1.0)) (incf p)))))
;     (progn
;       (compile 'xn)
;       (compile 'f)
;       (xn)))
;   => :done)

;; 2010-12-10  NANRI Masaoki  <southly@gmail.com>
;; 
;; 	* src : fix (cdr '#1='#1#) printing.
;; 	http://blog.bugyo.tk/lyrical/archives/610
;; 	http://blog.practical-scheme.net/gauche/20100609-curious-circular-list
;; 	u(cdr '#1='#1#)v̕]ʂ̈󎚂ŃX^bNI[o[t[̂CB
;; 	'#1='#1#              => #1='#1#
;; 	(cdr '#1='#1#)        => #1=((quote . #1#))
;; 	(cdr '#1=(quote #1#)) => #1=((quote . #1#))
;; 	(cdr '#1=(q #1#))     => #1=((q . #1#))
;;
(deftest |fix (cdr '#1='#1#) printing| ()
  "u(cdr '#1='#1#)v̕]ʂ̈󎚂ŃX^bNI[o[t[̂CB"
  (eval-in-another-xyzzy
   '(with-output-to-string (*standard-output*)
     (write (cdr '#1='#1#) :circle t))
   :options "-q")
  => "#1=((quote . #1#))")

;; 2010-12-01  NANRI Masaoki  <southly@gmail.com>
;; 
;; 	* src : fix macroexpand.
;; 	http://twitter.com/bowbow99/status/9887141152694272
;; 	Ԗڂ̖߂lԂĂȂ̂CB
;; 	(macroexpand '(push 1 x))
;; 	=> (setq x (cons 1 x))
;; 	=> t
;; 	(macroexpand '(setq x (cons 1 x)))
;; 	=> (setq x (cons 1 x))
;; 	=> nil
;; 
(deftest fix-macroexpand-00 ()
  "macroexpand 2Ԗڂ̖߂lԂĂȂ̂C: WJꍇ t"
  (macroexpand '(push 1 x))
  => (setq x (cons 1 x))
  => t)

(deftest fix-macroexpand-01 ()
  "macroexpand 2Ԗڂ̖߂lԂĂȂ̂C: WJȂꍇ nil"
  (macroexpand '(setq x (cons 1 x)))
  => (setq x (cons 1 x))
  => nil)

;; 	* src : fix flet, labels, macrolet.
;; 	http://twitter.com/bowbow99/status/8011887295856640
;; 	̃`FbN̂CB
;; 	(flet () 3)     => 3
;; 	(flet ())       => nil
;; 	(labels () 3)   => 3
;; 	(labels ())     => nil
;; 	(macrolet () 3) => 3
;; 	(macrolet ())   => nil
;; 
(deftest fix-flet/labels/macrolet-00 ()
  "flet, labels, macrolet  BODY ɂƃG[ɂȂĂ̂C: flet"
  (flet ()) => nil)

(deftest fix-flet/labels/macrolet-01 ()
  "flet, labels, macrolet  BODY ɂƃG[ɂȂĂ̂C: labels"
  (labels ()) => nil)

(deftest fix-flet/labels/macrolet-02 ()
  "flet, labels, macrolet  BODY ɂƃG[ɂȂĂ̂C: macrolet"
  (macrolet ()) => nil)

;; 	* src : add "listp" Macro.
;; 	IuWFNg cons łA nil ł邩ǂׂ listp }N
;; 	ǉB
;; 

;; 2010-11-09  NANRI Masaoki  <southly@gmail.com>
;; 
;; 	* src : fix type-check in list-length.
;; 	http://twitter.com/bowbow99/status/1742537278623744
;; 	(list-length :foo)
;; 	-> sȃf[^^ł: :foo: list
;; 	(list-length '(a . b))
;; 	-> sȃf[^^ł: b: list
;; 
;; 	dotted listnƂ̃G[bZ[W܂A
;; 	Ƃ肠̂܂܁B
;; 
(deftest fix-type-check-in-list-length-00 ()
  "list-length ̌^`FbNB"
  (list-length :foo)
  !! type-error)

(deftest fix-type-check-in-list-length-01 ()
  "list-length ̌^`FbNBhbgXg_B"
  (list-length '(a . b))
  !! type-error)

;; 	* src : fix nthcdr given dotted list.
;; 	http://twitter.com/bowbow99/status/1746294087352320
;; 	(nthcdr 0 '()) => nil
;; 	(nthcdr 3 '()) => nil
;; 	(nthcdr 0 '(a b c)) => (a b c)
;; 	(nthcdr 2 '(a b c)) => (c)
;; 	(nthcdr 4 '(a b c)) => nil
;; 	(nthcdr 1 '(0 . 1)) => 1
;; 	(nthcdr 3 '(0 . 1)) => nil
;; 
;; 	Ō̃P[X̓G[ɂׂǁAƂ肠̂܂܁B
;;

;; NOTE: 05 ȊO͌炿Ɠ
; (deftest fix-nthcdr-given-dotted-list-00 ()
;   (nthcdr 0 '()) => nil)

; (deftest fix-nthcdr-given-dotted-list-01 ()
;   (nthcdr 3 '()) => nil)

; (deftest fix-nthcdr-given-dotted-list-02 ()
;   (nthcdr 0 '(a b c)) => (a b c))

; (deftest fix-nthcdr-given-dotted-list-03 ()
;   (nthcdr 2 '(a b c)) => (c))

; (deftest fix-nthcdr-given-dotted-list-04 ()
;   (nthcdr 4 '(a b c)) => nil)

(deftest fix-nthcdr-given-dotted-list-05 ()
  "nthcdr hbgXgɑΉB"
  (nthcdr 1 '(0 . 1)) => 1)

; (deftest fix-nthcdr-given-dotted-list-06 ()
;   (nthcdr 3 '(0 . 1)) => nil)


;; 	* src : fix single-float-epsilon, single-float-negative-epsilon.
;; 	http://twitter.com/TwilightClover/status/26251344464
;; 	http://gist.github.com/608561
;; 	http://gist.github.com/608467
;; 	(dolist (sym '((double-float-epsilon t)
;; 	               (double-float-negative-epsilon nil)
;; 	               (long-float-epsilon t)
;; 	               (long-float-negative-epsilon nil)
;; 	               (short-float-epsilon t)
;; 	               (short-float-negative-epsilon nil)
;; 	               (single-float-epsilon t)
;; 	               (single-float-negative-epsilon nil)))
;; 	  (let ((epsilon (symbol-value (car sym)))
;; 	        (positive (cadr sym)))
;; 	    (format t "~30S = ~@30S, test = ~S~%"
;; 	            (car sym)
;; 	            epsilon
;; 	            (if positive
;; 	                (not (= (float 1 epsilon) (+ (float 1 epsilon) epsilon)))
;; 	              (not (= (float 1 epsilon) (- (float 1 epsilon) epsilon)))))
;; 	    ))
;; 	double-float-epsilon           =          2.220446049250313d-16, test = t
;; 	double-float-negative-epsilon  =          1.110223024625157d-16, test = t
;; 	long-float-epsilon             =          2.220446049250313d-16, test = t
;; 	long-float-negative-epsilon    =          1.110223024625157d-16, test = t
;; 	short-float-epsilon            =                    1.192093e-7, test = t
;; 	short-float-negative-epsilon   =                    5.960464e-8, test = t
;; 	single-float-epsilon           =                    1.192093e-7, test = t
;; 	single-float-negative-epsilon  =                    5.960464e-8, test = t
;; 	nil
;; 
(deftest fix-single-float-eplilon ()
  "single-float-epsilon Ƃ̒Ԃ̒lA{x̂ƓɂȂĂ܂Ă̂CB"
  (dolist (sym '((double-float-epsilon t)
                 (double-float-negative-epsilon nil)
                 (long-float-epsilon t)
                 (long-float-negative-epsilon nil)
                 (short-float-epsilon t)
                 (short-float-negative-epsilon nil)
                 (single-float-epsilon t)
                 (single-float-negative-epsilon nil)))
    (let ((epsilon (symbol-value (car sym)))
          (positive (cadr sym)))
      (format t "~30S = ~@30S, test = ~S~%"
              (car sym)
              epsilon
              (if positive
                  (not (= (float 1 epsilon) (+ (float 1 epsilon) epsilon)))
                (not (= (float 1 epsilon) (- (float 1 epsilon) epsilon)))))
      ))
  >> double-float-epsilon           =          2.220446049250313d-16, test = t
  >> double-float-negative-epsilon  =          1.110223024625157d-16, test = t
  >> long-float-epsilon             =          2.220446049250313d-16, test = t
  >> long-float-negative-epsilon    =          1.110223024625157d-16, test = t
  >> short-float-epsilon            =                    1.192093e-7, test = t
  >> short-float-negative-epsilon   =                    5.960464e-8, test = t
  >> single-float-epsilon           =                    1.192093e-7, test = t
  >> single-float-negative-epsilon  =                    5.960464e-8, test = t
  >> 
  => nil
  )

;; 2010-09-30  MIYAMUKO Katsuyuki  <miyamuko@gmail.com>
;; 
;; 	* src : add deleted-window-p
;; 	폜ꂽ Window Ȃ t ԂB
;; 	deleted-buffer-p  Window o[WB
;; 	http://twitter.com/bowbow99/status/25935896653
;;

;; NOTE: OŗpӂĂꍇ pass Ă܂B
(deftest add-deleted-window-p-00 ()
  "폜ꂽ window Ȃ t Ԃ deleted-window-p ǉB
֐ǂ`FbNB"
  (fboundp 'deleted-window-p)
  => non-nil)

;; NOTE: OŗpӂĂꍇ pass Ă܂B
(deftest add-deleted-window-p-01 ()
  "폜ꂽ window Ȃ t Ԃ deleted-window-p ǉB
폜ꂽ window  t Ԃ`FbNB"
  (let ((current (selected-window))
        (new     (save-window-excursion
                   (split-window -1)
                   (selected-window))))
    (deleted-window-p new))
  => non-nil)

(deftest add-deleted-window-p-02 ()
  "폜ꂽ window Ȃ t Ԃ deleted-window-p ǉB
rgC֐ǂ`FbNB"
  (si:*builtin-function-p (symbol-function 'deleted-window-p))
  => non-nil)

;; 2010-09-12  MIYAMUKO Katsuyuki  <miyamuko@gmail.com>
;; 
;; 	* src : add optional value parameter to si:putenv.
;; 	ϐƃIvViȒlƂ悤ɕύXB
;; 	lȗꍇ nil w肵ꍇ͊ϐ폜B
;; 	߂l͊ϐ̐ݒɐꍇ͐ݒ肵lԂA
;; 	ϐ폜ꍇ܂͐ݒɎsꍇ nil Ԃ悤ɕύXB
;; 	(si:putenv "FOO" "bar")
;; 	=> "bar"
;; 	(si:putenv "FOO")
;; 	=> nil
;; 	(si:putenv "=FOO" "bar")
;; 	=> nil
;; 
(deftest add-putenv-00 ()
  "֐ si:putenv ǉ (VARNAME &optional VALUE) "
  (multiple-value-bind (sym class)
      (find-symbol "putenv" :system)
    class)
  => :external)

(deftest add-putend-01 ()
  "֐ si:putenv ǉ (VARNAME &optional VALUE) "
  (fboundp (find-symbol "putenv" :system))
  => non-nil)

(deftest add-putenv-02 ()
  "֐ si:putenv ǉ (VARNAME &optional VALUE) "
  (funcall (find-symbol "putenv" :system) "FOO" "bar")
  => "bar")

(deftest add-putenv-03 ()
  "֐ si:putenv ǉ (VARNAME &optional VALUE) "
  (progn
    (funcall (find-symbol "putenv" :system) "FOO" "baz")
    (si:getenv "FOO"))
  => "baz")

(deftest add-putenv-04 ()
  "֐ si:putenv ǉ (VARNAME &optional VALUE) "
  (values
   (funcall (find-symbol "putenv" :system) "FOO" nil)
   (si:getenv "FOO"))
  => nil
  => nil)

;; 2010-09-11  NANRI Masaoki  <southly@gmail.com>
;; 
;; 	* src : remove redefinition.
;; 	Microsoft Visual C++ 2010 ł wingdi.h CN[hāA
;; 	tagWCRANGE  tagGLYPHSET `悤Ȃ̂ gen-fontrange.cc ł
;; 	`폜B
;; 	Ƃ肠VC2010ł̂ݍ폜B
;; 

;; 	* src : remove pragma optimize.
;; 	uinternal compiler errorv΍Ƃ̃Rg邪AMicrosoft Visual
;; 	C++ 2010 ł̓G[Ȃ̂ō폜B
;; 	Ƃ肠VC2010ł̂ݍ폜B
;; 

;; 	* src : add si:putenv.
;; 	si:putenv ǉB
;; 	via http://d.hatena.ne.jp/miyamuko/20100910/xyzzy_putenv
;; 
;; NOTE: ̌ύXĂłŃeXg

;; 2010-08-31  NANRI Masaoki  <southly@gmail.com>
;; 
;; 	* src : fix call-process.
;; 	call-process̕ẂEWo͓̎w肪܂ݒ肳Ȃۂ
;; 	Ă̂CB
;;
;; TODO: command prompt u\̂
;; FIXME: 0.2.2.235  pass Ă܂Bǂꍇɏ肭ݒ肳Ȃ̂킩B
; (deftest fix-call-process-input/output ()
;   (labels ((make-file (name &optional contents)
;              (with-open-file (out name
;                                   :direction :output
;                                   :if-does-not-exist :create)
;                (when (princ contents out)))
;              name))
;     (let ((infile (make-file (make-temp-file-name) "hello"))
;           (outfile (make-file (make-temp-file-name) "")))
;       (call-process "sort" :input infile :output outfile :wait t)
;       (unwind-protect
;           (with-open-file (in outfile :direction :input)
;             (read in))
;         (delete-file infile)
;         (delete-file outfile))))
;   => hello
;   )

;; 2010-07-14  NANRI Masaoki  <southly@gmail.com>
;; 
;; 	* src : fix format "~T".
;; 	u~colnum,colincTv̂ƂAucolnum+k*colincv𖞂ŏ̐̐k
;; 	߂悤ɏCB
;; 	(format nil "~0,1T")
;; 	=> " "
;; 
(deftest fix-format-T ()
  (format t "~0,1Tx")
  >>  x
  => nil)

;; 	* src : fox format "~VT" in the case of being provided '() as a prefix parameter.
;; 	VɈƂnilnƂ̓CB
;; 	(format t "~VA" nil 'x)
;; 	== (format t "~A" 'x)
;; 
(deftest fix-format-VT ()
  (format t "~VA" nil 'x)
  >> x
  => nil)

;; 	* src : fix for VC2010.
;; 	Microsoft Visual C++ 2010 ł̃rhpɏCB
;; 	MakefilȅĈ݁B
;; 

;; 2010-04-04  NANRI Masaoki  <southly@gmail.com>
;; 
;; 	* src : add repl.
;; 	R}hvvg\o[Wxyzzyrpl.exe쐬ł悤ɂ
;; 	Bunmake replvō쐬łB
;; 
;; 	;;; ȈREPL
;; 	(defun repl ()
;; 	  (interactive)
;; 	  (let ((*standard-input* *terminal-io*)
;; 	        (*standard-output* *terminal-io*))
;; 	    (loop
;; 	      (format t "~%> ")
;; 	      (format t "~A" (eval (read *standard-input*))))))
;; 
;; NOTE: merge ĂȂixyzzy Part17 >>593 http://toro.2ch.net/test/read.cgi/win/1303662374/593j

;; 2010-03-01  NANRI Masaoki  <southly@gmail.com>
;; 
;; 	* src : fix "*load-pathname*" initialization.
;; 	_v쐬Ƀ[ht@Ĉ܂܃_vt@Cɕۑ
;; 	悤Ȃ̂ŁANɂ悤ɏCB
;; 
(deftest fix-*load-pathname*-from-dump-image ()
  "_v쐬Ƀ[ht@Ĉ܂܃_vt@Cɕۑ
悤Ȃ̂ŁANɂ悤ɏCB"
  ;; FIXME: _vC[W܂ꍇ pass Ă܂B
  (eval-in-another-xyzzy
   `*load-pathname*
   :options "-q")
  => nil
  )

;; 	* src : fix format "~F".
;; 	format"~F"̑p[^ww肵ȂƑOp[^k@\Ȃ
;; 	̂CB
;; 
;; 	(dotimes (i 10)
;; 	  (format t "~,,VF~%" i pi))
;; 	3.141592653589793
;; 	31.41592653589793
;; 	314.1592653589793
;; 	3141.592653589793
;; 	31415.92653589793
;; 	314159.2653589793
;; 	3141592.653589793
;; 	31415926.53589793
;; 	314159265.3589793
;; 	3141592653.589793
;; 	nil
;; 
;; 	(do ((i -9 (1+ i)))
;; 	    ((> i 9))
;; 	  (format t "~,,VF~%" i pi))
;; 	-0.000000009
;; 	-0.00000008
;; 	-0.0000007
;; 	-0.000006
;; 	-0.00005
;; 	-0.0004
;; 	-0.003
;; 	-0.02
;; 	-0.1
;; 	0.0
;; 	10.0
;; 	200.0
;; 	3000.0
;; 	40000.0
;; 	500000.0
;; 	6000000.0
;; 	70000000.0
;; 	800000000.0
;; 	9000000000.0
;; 	nil
;;
(deftest fix-format-F-01 ()
  (dotimes (i 10)
    (format t "~,,VF~%" i pi))
  >> 3.141592653589793
  >> 31.41592653589793
  >> 314.1592653589793
  >> 3141.592653589793
  >> 31415.92653589793
  >> 314159.2653589793
  >> 3141592.653589793
  >> 31415926.53589793
  >> 314159265.3589793
  >> 3141592653.589793
  >> 
  => nil
  )


(deftest fix-format-F-02 ()
  (do ((i -9 (1+ i)))
      ((> i 9))
    (format t "~,,VF~%" i i))
  >> -0.000000009
  >> -0.00000008
  >> -0.0000007
  >> -0.000006
  >> -0.00005
  >> -0.0004
  >> -0.003
  >> -0.02
  >> -0.1
  >> 0.0
  >> 10.0
  >> 200.0
  >> 3000.0
  >> 40000.0
  >> 500000.0
  >> 6000000.0
  >> 70000000.0
  >> 800000000.0
  >> 9000000000.0
  >> 
  => nil
  )

;; 2010-02-21  NANRI Masaoki  <southly@gmail.com>
;; 
;; 	* src : fix applyhook.
;; 	applyhook, *applyhook* [J֐ɑΉB
;; 	call_applyhook̑ɃN[Wn悤ɕύXB
;; 
(deftest fix-applyhook-00 ()
  "applyhook, *applyhook* [J֐ɑΉB"
  (let ((*applyhook* (lambda (fn args)
                       (functionp fn))))
    (car 1))
  => non-nil)

;; 	* src : add "*read-eval*".
;; 	XyVϐ*read-eval*@\悤ɂB
;; 	*read-eval*̏o͂ւ̉e̗B
;; 	*read-eval*nil̏ꍇencodingunreadable-objectƂďo͂悤
;; 	Ă邪AMȂB
;; 
(deftest add-*read-eval*-00 ()
  "XyVϐ*read-eval*@\悤ɂB"
  (si:*specialp '*read-eval*)
  => non-nil)

(deftest add-*read-eval*-01 ()
  "XyVϐ*read-eval*@\悤ɂB"
  (let ((*read-eval* nil))
    (read-from-string "#.(+ 1 2)"))
  !! reader-error)

;; TODO: o͂ւ̉eH

;; 2010-01-23  NANRI Masaoki  <southly@gmail.com>
;; 
;; 	* src : fix for VC2008.
;; 	Microsoft Visual C++ 2008 ł̃rhpɏCB
;; 	http://xyzzy.s53.xrea.com/wiki/index.php?Memo%2F%A5%BD%A1%BC%A5%B9%A4%AB%A4%E9%A5%D3%A5%EB%A5%C9%A4%B7%A4%C6%A4%DF%A4%EB3
;; 
;; NOTE: eXg͂ƎvǁAcommit ȂB

;; 	* src : add get-buffer-colors.
;; 	֐get-buffer-colorsǉB
;; 	set-buffer-colorsƑ΂ƂȂ錻݂̃obt@̐Fݒ擾֐B
;;
(deftest add-get-buffer-colors-00 ()
  "֐get-buffer-colorsǉB"
  (fboundp 'get-buffer-colors)
  => non-nil)

;; NOTE: NANRI 񂩂̒; thx
(deftest add-get-buffer-colors-01 ()
  "֐get-buffer-colors݂͌̃obt@̐FݒԂB"
  (flet ((make-tmp-colors ()
           (let ((l (list #xffffff #x000000)))
             (dotimes (i 16)
               (push (* i #x111111) l))
             (make-vector 18 :initial-contents (nreverse l)))))
    (let ((colors (make-tmp-colors))
          (buf (create-new-buffer "test get-buffer-colors")))
      (save-excursion
        (with-set-buffer
          (set-buffer buf)
          (unwind-protect
              (progn
                (set-buffer-colors colors)
                (equalp colors (get-buffer-colors buf)))
            (delete-buffer buf))))))
  => non-nil)

;; 2010-01-22  NANRI Masaoki  <southly@gmail.com>
;; 
;; 	* src : fix listen.
;; 	EOF̂ƂnilԂ悤ɏCB
;; 	͈͂ƂƂstring-streamfile-streamB
;; 
(deftest fix-listen-for-string-stream ()
  "EOF̂ƂnilԂ悤ɏCistring-streamj"
  (let ((stream (make-string-input-stream "")))
    (listen stream))
  => nil)

(deftest fix-listen-for-file-stream ()
  "EOF̂ƂnilԂ悤ɏCifile-streamj"
  (with-temp-files (file)
    (with-open-file (in file :direction :input)
      (listen in)))
  => nil)

;; 2010-01-11  NANRI Masaoki  <southly@gmail.com>
;; 
;; 	* src : fix save-window-excursion.
;; 	(save-window-excursion (values 1 2 3))
;; 	ŐlԂȂꍇ̂CB
;; 	xyzzy Part11 8 http://www.bookshelf.jp/2ch/win/1085301777.html
;;
;; 	WindowConfiguratioñfXgN^Lisp̃R[hŝŁA
;; 	WindowConfiguratioñfXgN^sƂŁAl̒lɖ
;; 	KvB
;; 
;; FIXME: CłlԂ邱Ƃ݂Ȃ̂ŁA̎ pass Ă܂
(deftest fix-save-window-excursion ()
  "lԂȂꍇ̂C"
  (save-window-excursion (values 1 2 3))
  => 1
  => 2
  => 3)

;; 	* lisp : fix long-operation.
;; 	long-operation̖߂lprog1ɂȂĂ̂prognɂȂ
;; 	ɏCB
;; 	xyzzy Part10 470
;; 
(deftest fix-long-operation ()
  "long-operation̖߂lprog1ɂȂĂ̂prognɂȂ
ɏCB"
  (long-operation
    1
    2)
  => 2)

;; 2009-12-26  NANRI Masaoki  <southly@gmail.com>
;; 
;; 	* src : update zlib.
;; 	zlibo[W1.2.3ɃAbvf[gB
;; 

;; 2009-12-17  NANRI Masaoki  <southly@gmail.com>
;; 
;; 	* lisp : modify tags-setup-buffer.
;; 	XTAGSt@CTʒuXύXB
;; 
;; NOTE: merge ĂȂixyzzy Part17 >>593 http://toro.2ch.net/test/read.cgi/win/1303662374/593j

;; 	* lisp : modify edict-lookup-word.
;; 	PJ[\̑OɕύXB
;; 
;; NOTE: merge ĂȂixyzzy Part17 >>593 http://toro.2ch.net/test/read.cgi/win/1303662374/593j

;; 	* lisp : modify start point in buffer-menu.
;; 	buffer-menusƂ̃J[\ʒũ݂obt@̈ʒuɕύXB
;;
;; NOTE: merge ĂȂixyzzy Part17 >>593 http://toro.2ch.net/test/read.cgi/win/1303662374/593j
; (deftest modify-start-point-in-buffer-menu ()
;   (let ((buffers '()))
;     (do ((i 0 (1+ i)))
;         ((>= i 4))
;       (push (create-new-buffer "*Test Example*") buffers))
;     (prog1
;         (save-window-excursion
;           (with-set-buffer
;             (set-buffer (car buffers))
;             (buffer-menu)
;             (and (bolp)
;                  (looking-at "^\\."))))
;       (dolist (b buffers)
;         (delete-buffer b)))))

;; 	* src : add key parameter ":show" to make-process.
;; 	make-processɃL[p[^ :show ǉB
;; 	http://xyzzy.s53.xrea.com/wiki/index.php?patch%2F12
;; 
;; FIXME: eXg@vȂ

;; 2009-12-16  NANRI Masaoki  <southly@gmail.com>
;; 
;; 	* src : support IMR_DOCUMENTFEED.
;; 	via http://fixdap.com/p/xyzzy/7376/
;; 	ȉœmFB
;; 	@@@@@
;; 	z@@@@@@
;; 	Ԃ@@@@@@t
;; 	Ԃ@@@@@
;; 
;; FIXME: eXg@vȂ

;; 	* src : fix set-buffer-modified-p.
;; 	(set-buffer-modified-p nil) ɈȑOXVȂԂ_X
;; 	VԂ̂܂܂Ȃ̂CB
;;
;; TODO: ύX̓e悭킩̂Ō
; (deftest fix-set-buffer-modified-p ()
;   (let ((buffer (create-new-buffer "*Example*")))
;     (set-buffer-modified-p nil buffer)
;     (buffer-modified-p buffer))
;   => nil)

;; 	* src : fix inverse-cursor-line.
;; 	(setq inverse-cursor-line t)
;; 	̏ԂɂƍsJ[\Ɛ܂Ԃ̌_]܂܎cĂ
;; 	̂CB
;;
;; FIXME: eXg@vȂ

;; 2009-12-09  NANRI Masaoki  <southly@gmail.com>
;; 
;; 	* src : add "*brackets-is-wildcard-character*" to history-variable.
;; 	ʐݒ́u[...]̓ChJ[hv̐ݒ肪ۑȂ̂ŁAΉ
;; 	ϐqXgɒǉB
;;
(deftest add-*brackets-is-wildcard-character*-to-history-variable ()
  "ʐݒ́u[...]̓ChJ[hv̐ݒ肪ۑȂ̂ŁAΉ
ϐqXgɒǉB"
  (member '*brackets-is-wildcard-character* ed::*history-variable-list*)
  => non-nil)

;; 	* src : fix dump hash-table.
;; 	V{L[̃nbVe[u_vt@CɓꂽꍇA
;; 	gethashŒlƂȂ肪BAmaphashőSvf擾
;; 	邱Ƃ͂łB
;; 	---- $XYZZY/site-lisp/siteinit.l ̓e
;; 	(defparameter *hash* (make-hash-table))
;; 	(dolist (i '((aaa . abab) (bbb . bcbc) (ccc . cdcd)))
;; 	  (setf (gethash (car i) *hash*) (cdr i)))
;; 	---- _vt@C[hƂɕ]
;; 	(gethash 'aaa *hash*)
;; 	=>nil ; { abab
;; 	=>nil ;        t
;; 
;; 	(maphash #'(lambda (key val) (format t "~S: ~S~%" key val)) *hash*)
;; 	aaa: abab
;; 	bbb: bcbc
;; 	ccc: cdcd
;; 	=>nil
;; 	----
;; 	V{̃nbVl̓IuWFNg̃AhXɌvZĂ邪A
;; 	_vt@C쐬ƃ_vt@C[hł̓V{IuWFN
;; 	g̃AhXقȂÃnbVlɂȂȂ̂B
;; 
;; 	_vt@C[hƂrehash悤ɏCB
;;

;; FIXME: _~[ site-lisp/siteinit.l pӂĂɂȂ炵B
; (deftest fix-dump-hash-table ()
;   (progn
;     (with-another-xyzzy (:options "-q")
;       (defparameter *hash* (make-hash-table))
;       (dolist (i '((aaa . abab) (bbb . bcbc) (ccc . cdcd)))
;         (setf (gethash (car i) *hash*) (cdr i)))
;       (dump-xyzzy (merge-pathnames "dump-image-for-test.wxp" (si:system-root))))
;     (let ((image-name (merge-pathnames "dump-image-for-test.wxp" (si:system-root))))
;       (unless (file-exist-p image-name)
;         (error "Failed to create dump-image."))
;       (multiple-value-prog1
;           (with-another-xyzzy (:options (format nil "-image ~S -q" image-name))
;             (gethash 'aaa *hash*))
;         ;(delete-file image-name)
;         )))
;   => abab
;   => t)

;; 	* lisp : fix defpackage.
;; 	defpackage}N:exportIvVwłȂsCB
;; 	[xyzzy:09241]
;; 
(deftest fix-depackage-export ()
  "defpackage}N:exportIvVwłȂsCB"
  (defpackage :example
    (:export #:foo))
  == (eval-when (:compile-toplevel :load-toplevel :execute)
       (let* ((package (or (find-package "example")
                           (make-package "example"))))
         (export (mapcar #'(lambda (lisp::x)
                             (intern lisp::x package))
                   '("foo"))
                 package)
         package)))

;; 	* lisp : fix shell-alternate-send-input.
;; 	http://xyzzy.s53.xrea.com/wiki/index.php?patch%2F15
;; 

(require "shell")

(deftest fix-shell-alternate-send-input ()
  "shell-alternate-send-input ͉sR[hXCb`悤ɏC"
  (labels ((mocked-shell-send-input ()
             *shell-ret*))
    (let ((original-shell-send-input #'shell-send-input))
      (setf (symbol-function 'shell-send-input) #'mocked-shell-send-input)
      (unwind-protect
          (let ((*shell-ret* "\n"))
            (shell-alternate-send-input))
        (setf (symbol-function 'shell-send-input) original-shell-send-input))))
  => "\r")

;; 	* lisp : fix calendar.
;; 	J_[̏js@ɂ킹B
;; 	[xyzzy:09224]
;; 
(require "calendar")

(defun calendar-japanese-holiday-spec (year month day)
  (let ((v (make-vector 33)))
    (ed::calendar-japanese-holiday year month v)
    (svref v day)))

(deftest fix-calendar-01 ()
  "calendar ̏js@ɍ킹"
  (calendar-japanese-holiday-spec 2007 4 29)
  => "a̓")

(deftest fix-calendar-02 ()
  "calendar ̏js@ɍ킹"
  (calendar-japanese-holiday-spec 2007 5 4)
  => "݂ǂ̓")

(deftest fix-calendar-03 ()
  "calendar ̏js@ɍ킹"
  (calendar-japanese-holiday-spec 2008 5 6)
  => "U֋x")


;; 	* lisp : fix typo in lisp/timestmp.l.
;; 	RgtypoCB
;; 	[xyzzy:09158]
;;

;; 	* lisp : fix typo in lisp/encoding.l.
;; 	providetypoCB
;; 	[xyzzy:09158]
;;
(deftest fix-typo-in-lisp/encoding.l ()
  "lisp/encoding.l  provide Ă郂W[ typo C"
  (modulep "encoding")
  => non-nil)

;; 	* lisp : fix typo in lisp/css-mode.l.
;; 	providetypoCB
;; 	[xyzzy:09158]
;;
(deftest fix-typo-in-lisp/css-mode.l ()
  "lisp/css-mode.l  provide Ă郂W[ typo C"
  (progn
    (require "css-mode")
    (and (modulep "css-mode")
         (not (modulep "cssmode"))))
  => non-nil)

;; 	* lisp : fix typo in lisp/builtin.l.
;; 	ɈtypoCB
;; 	[xyzzy:09158]
;;
(deftest fix-typo-in-lisp/builtin--sort ()
  "builtin.l  typo C: sort"
  (get 'sort 'si::builtin-function-argument #1='#:undefined)
  => (sequence lisp::predicate &key :key))

(deftest fix-typo-in-lisp/builtin--rename-file ()
  "builtin.l  typo C: rename-file"
  (get 'rename-file 'si::builtin-function-argument #1='#:undefined)
  => (lisp::file lisp::new-name &key :if-exists :if-access-denied))

(deftest fix-typo-in-lisp/builtin--copy-file ()
  "builtin.l  typo C: copy-file"
  (get 'copy-file 'si::builtin-function-argument #1='#:undefined)
  => (lisp::file lisp::new-file &key :if-exists :copy-attributes :if-access-denied))

(deftest fix-typo-in-lisp/builtin--dump-image-path ()
  "builtin.l  typo C: si:dump-image-path"
  (get 'system:dump-image-path 'si::builtin-function-argument #1='#:undefined)
  => nil)

(deftest fix-typo-in-lisp/builtin--char-before ()
  "builtin.l  typo C: char-before"
  (get 'char-before 'si::builtin-function-argument #1='#:undefined)
  => (point &optional editor::not-used))

(deftest fix-typo-in-lisp/builtin--file-name-dialog ()
  "builtin.l  typo C: file-name-dialog"
  (get 'file-name-dialog 'si::builtin-function-argument #1='#:undefined)
  => (&key :char-encoding :eol-code :filter :filter-index :title :default :extension :save :multiple :must-exist :explorer :hide-read-only :initial-directory))

(deftest fix-typo-in-lisp/builtin--directory-name-dialog ()
  "builtin.l  typo C: directory-name-dialog"
  (get 'directory-name-dialog 'si::builtin-function-argument #1='#:undefined)
  => (&key :title :default))

(deftest fix-typo-in-lisp/builtin--make-iso2022-encoding ()
  "builtin.l  typo C: make-iso2022-ecnoding"
  (get 'make-iso2022-encoding 'si::builtin-function-argument #1='#:undefined)
  => (editor::name editor::display-name &key :g0 :g1 :g2 :g3 :ascii-eol :ascii-control :7bits :locking-shift :short-form :no-escape :cjk :use-cns11643 :vender))

(deftest fix-typo-in-lisp/builtin--make-utf16-encoding ()
  "builtin.l  typo C: make-utf16-encoding"
  (get 'make-utf16-encoding 'si::builtin-function-argument #1='#:undefined)
  => (editor::name editor::display-name &key :signature :byte-order :windows :cjk))

(deftest fix-typo-in-lisp/builtin--make-utf8-encoding ()
  "builtin.l  typo C: make-utf8-encoding"
  (get 'make-utf8-encoding 'si::builtin-function-argument #1='#:undefined)
  => (editor::name editor::display-name &key :signature :windows :cjk))

(deftest fix-typo-in-lisp/builtin--make-utf7-encoding ()
  "builtin.l  typo C: make-utf7-encoding"
  (get 'make-utf7-encoding 'si::builtin-function-argument #1='#:undefined)
  => (editor::name editor::display-name &key :windows :imap4 :white :set-o :cjk))

(deftest fix-typo-in-lisp/builtin--make-utf5-encoding ()
  "builtin.l  typo C: make-utf5-encoding"
  (get 'make-utf5-encoding 'si::builtin-function-argument #1='#:undefined)
  => (editor::name editor::display-name &key :windows :imap4 :white :set-o :cjk))

(deftest fix-typo-in-lisp/builtin--parse-char-encoding-string ()
  "builtin.l  typo C: parse-char-encoding-string"
  (get 'parse-char-encoding-string 'si::builtin-function-argument #1='#:undefined)
  => (editor::accept-char-encoding string &key :start :end))

;; 	* src : fix hash-table rehash size.
;; 	nbVe[u̗vf80000zӂ肩AnbVe[u
;; 	TCY̑ʂ100ɌŒ肳B̂ߕpɂrehashptH[}
;; 	XቺĂB
;; 	rehashƂ͍ŒłÕTCY1.5{ɂȂ悤ɂB
;;
;; NOTE: ₽ƎԊ|ŕۗ
;; Ref: https://gist.github.com/227683

;; 	* src : fix ole-method.
;; 	ole-method ŕnƗ]v 0x00 t
;; 	via http://fixdap.com/p/xyzzy/8379/
;; 	via http://d.hatena.ne.jp/miyamuko/20080304/xyzzy_ole_method_bug
;;
;; NOTE: miyamuko 񂩂̒; thx
(deftest fix-ole-method ()
  "ole-method ŕnƗ]v 0x00 t"
  (flet ((ole-create-file (content)
           (with-temp-files (tmp)
             (let* ((fso (ole-create-object "Scripting.FileSystemObject"))
                    (file (ole-method fso 'OpenTextFile tmp 2)))
               (unwind-protect
                   (ole-method file 'Write content)
                 (ole-method file 'Close))
               (file-length tmp)))))
    (values (ole-create-file "")
            (ole-create-file "f")
            (ole-create-file "foo")))
  => 0
  => 1
  => 3)


;; 	* src : fix for FFI.
;; 	߂l double, float  C ֐ĂԂƃNbV
;; 	http://xyzzy.s53.xrea.com/wiki/index.php?patch%2F25
;; 	via http://d.hatena.ne.jp/miyamuko/20070509/p1
;;
(deftest fix-for-FFI-c-function-return-doubl/float-00 ()
  "߂l double, float  C ֐ĂԂƃNbV"
  (eval-in-another-xyzzy
    `(labels ((c (name) (find-symbol name :c)))
       (require "foreign")
       (eval `(,(c "define-dll-entry")
               ,(c "double")
               strtod (,(c "char*") (,(c "char*") *))
               "msvcrt"))
       (strtod (si:make-string-chunk "123") 0))
    :options "-q" :timeout 6)
  => 123.0d0
  )


;; 	* src : fix start-timer.
;; 	http://xyzzy.s53.xrea.com/wiki/index.php?patch%2F21
;; 

;; NOTE: ^C}[obNOEhŃeXgs sleep-for Ă
;; start-timer ֐sȂ̂ŕԂĂȂȂB̂Ń^CAEg
;; ĂB
(deftest fix-start-timer ()
  (let ((n 0)
        (start (get-internal-real-time))
        thunk
        (finish nil))
    (setf thunk (lambda ()
                  (when (>= (incf n) 3)
                    (stop-timer thunk)
                    (setf finish (get-internal-real-time)))))
    (start-timer 0.5 thunk)
    (while (not finish)
      (sleep-for 0.2)
      (when (> (- (get-internal-real-time) start) 6000)
        (error "fix-start-timer test timeout.")))
    (> (- finish start) 1400))
  => non-nil)

;; 	* src : fix format "~G".
;; 	[xyzzy:09204]
;;
;; 	http://hie.s64.xrea.com/xyzzy/ml/msg09203.html
(deftest fix-format-G ()
  (format t "~10g" 1.23456d+38)
  >> 123456000000000000000000000000000000000.0    
  => nil)

;; 	* src : fix format "~E".
;; 	[xyzzy:09204]
;;
;; 	http://hie.s64.xrea.com/xyzzy/ml/msg09202.html
(deftest fix-format-E-00 ()
  (format t "~E" 123.45)
  >> 1.2345e+2
  => nil)

(deftest fix-format-E-01 ()
  (format t "~0E" 123.45)
  >> 1.2345e+2
  => nil)

;; 	* src : fix format "~F".
;; 	[xyzzy:09204]
;;
;; 	http://hie.s64.xrea.com/xyzzy/ml/msg09202.html
(deftest fix-format-F-00 ()
  (format t "~@F" 123.45)
  >> +123.45
  => nil)

;; 	* src : fix format "~R".
;; 	[xyzzy:09198] http://hie.s64.xrea.com/xyzzy/ml/msg09197.html
;;
(deftest fix-format-R ()
  (format t "~16,10,'*,'-,2:R" #x123abc)
  >> **12-3a-bc
  => nil)

;; 	* src : fix for VC2005.
;; 	Microsoft Visual C++ 2005 Ńrhł悤ɁA܂܂ƏCB
;; 	http://xyzzy.s53.xrea.com/wiki/index.php?patch%2F13
;; 

;(when (yes-or-no-p "eXgH")
;  (test-changes))
;; ;;; nanri-master-change-tests.l ends here.
